﻿/*
 * The MIT License (MIT)
Copyright (c) 2013 João Tiago Pinheiro Neto Jacob
Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*
*/
using UnityEngine;
using System.Collections;

public class PlayerStatsScript : MonoBehaviour
{

    public int score = 0;
    public bool arMode = false;
    public float mapLimits;
    public Texture2D playerPin;
    public Texture2D barrelPin;
    private GUIStyle myStyle;
    private MapTexture mt;
    private Material mapMaterial;
    private float lLat;
    private float lLon;
    private float uLat;
    private float uLon;
    private Player player;
	// Use this for initialization
	void Start ()
	{
        player = GetComponent<Player>();
        lLat = (float)player.fakeLat - mapLimits;
        uLat = (float)player.fakeLat + mapLimits;

        lLon = (float)player.fakeLon - mapLimits;
        uLon = (float)player.fakeLon + mapLimits;
        mapMaterial = new Material("_MainTex");
        mt = new MapTexture();
        mt.mq_defaultSize = Screen.width/2;
        mt.getTexture(lLon.ToString(), lLat.ToString(), uLon.ToString(), uLat.ToString(), Application.persistentDataPath);
	}
	
	// Update is called once per frame
	void Update () {
	
	}

    void OnGUI()
    {
        myStyle = new GUIStyle(GUI.skin.label);
        myStyle.fontSize = 40;
        myStyle.fontStyle = FontStyle.Bold;
        GUI.Label(new Rect(Screen.width / 20.0f, Screen.height / 20.0f, Screen.width, Screen.height), "Score : " + score, myStyle);
        Rect mapArea = new Rect(lLon, lLat, uLon - lLon, uLat - lLat);
        if (!arMode)
        {
            var maxX = uLon - lLon;
            var maxY = uLat - lLat;
            var currentX = uLon - player.fakeLon;
            var currentY = uLat - player.fakeLat;
            var currentScreenX = currentX/maxX*Screen.width;
            var currentScreenY = currentY/maxY*Screen.height;
            GUI.depth = -1;
            GUI.DrawTexture(new Rect(0, 0, Screen.width, Screen.height), mt.texture,ScaleMode.StretchToFill);
            GUI.depth = 0;
            GUI.DrawTexture(new Rect((float)currentScreenX - playerPin.width, (float)currentScreenY - playerPin.height, playerPin.width, playerPin.height), playerPin, ScaleMode.StretchToFill);
            Debug.Log(currentScreenX + " " + currentScreenY);
            foreach(var barrel in GameObject.FindGameObjectsWithTag("Barrel"))
            {
                var barrelStats = barrel.GetComponent<RealObjectScript>();
				currentX = uLon - barrelStats.longitude;
				currentY = uLat - barrelStats.latitude;
                currentScreenX = currentX / maxX * Screen.width;
                currentScreenY = currentY / maxY * Screen.height;
                GUI.DrawTexture(new Rect(Screen.width - (float)currentScreenX, (float)currentScreenY , barrelPin.width, barrelPin.height), barrelPin, ScaleMode.StretchToFill);
            }
         
            if (GUI.Button(new Rect(0.05f * Screen.width, 0.8f * Screen.height, 0.1f*Screen.width, 0.05f*Screen.height),"AR Mode"))
            {
                arMode = true;
            }
        }
        else
        {
            if (GUI.Button(new Rect(0.05f * Screen.width, 0.8f * Screen.height, 0.1f*Screen.width, 0.05f*Screen.height),"Map Mode"))
            {
                arMode = false;
            }
        }
    }
}
