﻿/*
 * The MIT License (MIT)
Copyright (c) 2013 João Tiago Pinheiro Neto Jacob
Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*
*/
using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class RealObjectScript : MonoBehaviour
{
    public float latitude;
    public float longitude;
    public Transform relativeTo;
    private GeoUTMConverter converter;
    private float height = 0;
    private float initialHeight;
    public bool useRealHeight;
	// Use this for initialization
	void Start () {
        converter = new GeoUTMConverter();
	    converter.ToUTM(latitude,longitude);
        initialHeight = transform.position.y;
        if(useRealHeight)
        {
            GoogleElevation ge = new GoogleElevation();
            ge.coordinates = new List<float>();
            ge.coordinates.Add(latitude);
            ge.coordinates.Add(longitude);
            ge.SyncGetHeights();
            height = ge.heights[0];
        }
        
	}
	
	// Update is called once per frame
	void Update ()
	{
        var relativeConverter =  new GeoUTMConverter();
        relativeConverter.ToUTM(relativeTo.GetComponent<Player>().initialFakeLat, relativeTo.GetComponent<Player>().initialFakeLon);
        var newPos = new Vector3((float)converter.X, height + initialHeight, (float)converter.Y);
        newPos = newPos - new Vector3((float)relativeConverter.X, 0, (float)relativeConverter.Y);
	    transform.position = newPos;
	}
}
